diff --git a/CMakeLists.txt b/CMakeLists.txt
index 518132ecf7b..6bfcdbb4148 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -757,6 +757,8 @@ if( BUILD_SURGE_EFFECTS_BANK )
           JUCE_DISPLAY_SPLASH_SCREEN=0
           JUCE_REPORT_APP_USAGE=0
 
+          JUCE_MODAL_LOOPS_PERMITTED=1
+
           JUCE_COREGRAPHICS_DRAW_ASYNC=1
 
           JUCE_ALSA=1
@@ -915,6 +917,8 @@ if( BUILD_SURGE_XT )
           JUCE_DISPLAY_SPLASH_SCREEN=0
           JUCE_REPORT_APP_USAGE=0
 
+          JUCE_MODAL_LOOPS_PERMITTED=1
+
           JUCE_ALSA=1
           JUCE_JACK=1
 
diff --git a/src/common/dsp/QuadFilterChain.cpp b/src/common/dsp/QuadFilterChain.cpp
index 2910f9a1911..40334abfee6 100644
--- a/src/common/dsp/QuadFilterChain.cpp
+++ b/src/common/dsp/QuadFilterChain.cpp
@@ -49,7 +49,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, _mm_and_ps(mask, x)));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(d.wsLPF, d.Drive);
+                x = g.WSptr(&d.WSS[0], d.wsLPF, d.Drive);
             }
 
             if (A || WS)
@@ -87,7 +87,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, _mm_and_ps(mask, x)));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(d.wsLPF, d.Drive);
+                x = g.WSptr(&d.WSS[0], d.wsLPF, d.Drive);
             }
 
             if (A || WS)
@@ -127,7 +127,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, _mm_and_ps(mask, x)));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(d.wsLPF, d.Drive);
+                x = g.WSptr(&d.WSS[0], d.wsLPF, d.Drive);
             }
 
             if (A || WS)
@@ -176,7 +176,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, _mm_and_ps(mask, x)));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(d.wsLPF, d.Drive);
+                x = g.WSptr(&d.WSS[0], d.wsLPF, d.Drive);
             }
 
             d.Gain = _mm_add_ps(d.Gain, d.dGain);
@@ -202,7 +202,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, _mm_and_ps(mask, x)));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(d.wsLPF, d.Drive);
+                x = g.WSptr(&d.WSS[0], d.wsLPF, d.Drive);
             }
 
             if (B)
@@ -245,7 +245,7 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             {
                 d.wsLPF = _mm_mul_ps(hb_c, _mm_add_ps(d.wsLPF, x));
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(_mm_and_ps(mask, d.wsLPF), d.Drive);
+                x = g.WSptr(&d.WSS[0], _mm_and_ps(mask, d.wsLPF), d.Drive);
             }
 
             d.Gain = _mm_add_ps(d.Gain, d.dGain);
@@ -273,8 +273,8 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             if (WS)
             {
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(_mm_and_ps(mask, x), d.Drive);
-                y = g.WSptr(_mm_and_ps(mask, y), d.Drive);
+                x = g.WSptr(&d.WSS[0], _mm_and_ps(mask, x), d.Drive);
+                y = g.WSptr(&d.WSS[1], _mm_and_ps(mask, y), d.Drive);
             }
 
             d.Mix1 = _mm_add_ps(d.Mix1, d.dMix1);
@@ -314,8 +314,8 @@ void ProcessFBQuad(QuadFilterChainState &d, fbq_global &g, float *OutL, float *O
             if (WS)
             {
                 d.Drive = _mm_add_ps(d.Drive, d.dDrive);
-                x = g.WSptr(_mm_and_ps(mask, x), d.Drive);
-                y = g.WSptr(_mm_and_ps(mask, y), d.Drive);
+                x = g.WSptr(&d.WSS[0], _mm_and_ps(mask, x), d.Drive);
+                y = g.WSptr(&d.WSS[1], _mm_and_ps(mask, y), d.Drive);
             }
 
             if (A || WS)
diff --git a/src/common/dsp/QuadFilterChain.h b/src/common/dsp/QuadFilterChain.h
index aa0721d9519..269410d1964 100644
--- a/src/common/dsp/QuadFilterChain.h
+++ b/src/common/dsp/QuadFilterChain.h
@@ -102,7 +102,8 @@
 
 struct QuadFilterChainState
 {
-    QuadFilterUnitState FU[4];
+    QuadFilterUnitState FU[4];        // 2 filters left and righ
+    QuadFilterWaveshaperState WSS[2]; // 1 shaper left and right
 
     __m128 Gain, FB, Mix1, Mix2, Drive;
     __m128 dGain, dFB, dMix1, dMix2, dDrive;
diff --git a/src/common/dsp/QuadFilterUnit.cpp b/src/common/dsp/QuadFilterUnit.cpp
index 40832cd6881..d4da0fbf739 100644
--- a/src/common/dsp/QuadFilterUnit.cpp
+++ b/src/common/dsp/QuadFilterUnit.cpp
@@ -584,14 +584,14 @@ __m128 COMBquad_SSE2(QuadFilterUnitState *__restrict f, __m128 in)
     return _mm_add_ps(_mm_mul_ps(f->C[3], DBRead), _mm_mul_ps(f->C[2], in));
 }
 
-__m128 CLIP(__m128 in, __m128 drive)
+__m128 CLIP(QuadFilterWaveshaperState *__restrict s, __m128 in, __m128 drive)
 {
     const __m128 x_min = _mm_set1_ps(-1.0f);
     const __m128 x_max = _mm_set1_ps(1.0f);
     return _mm_max_ps(_mm_min_ps(_mm_mul_ps(in, drive), x_max), x_min);
 }
 
-__m128 DIGI_SSE2(__m128 in, __m128 drive)
+__m128 DIGI_SSE2(QuadFilterWaveshaperState *__restrict s, __m128 in, __m128 drive)
 {
     // v1.2: return (double)((int)((double)(x*p0inv*16.f+1.0)))*p0*0.0625f;
     const __m128 m16 = _mm_set1_ps(16.f);
@@ -604,12 +604,11 @@ __m128 DIGI_SSE2(__m128 in, __m128 drive)
     return _mm_mul_ps(drive, _mm_mul_ps(m16inv, _mm_sub_ps(_mm_cvtepi32_ps(a), mofs)));
 }
 
-__m128 TANH(__m128 in, __m128 drive)
+__m128 TANH(QuadFilterWaveshaperState *__restrict s, __m128 in, __m128 drive)
 {
     // Closer to ideal than TANH0
     // y = x * ( 27 + x * x ) / ( 27 + 9 * x * x );
     // y = clip(y)
-
     const __m128 m9 = _mm_set1_ps(9.f);
     const __m128 m27 = _mm_set1_ps(27.f);
 
@@ -624,7 +623,7 @@ __m128 TANH(__m128 in, __m128 drive)
     return _mm_max_ps(_mm_min_ps(y, y_max), y_min);
 }
 
-__m128 SINUS_SSE2(__m128 in, __m128 drive)
+__m128 SINUS_SSE2(QuadFilterWaveshaperState *__restrict s, __m128 in, __m128 drive)
 {
     const __m128 one = _mm_set1_ps(1.f);
     const __m128 m256 = _mm_set1_ps(256.f);
@@ -669,7 +668,7 @@ __m128 SINUS_SSE2(__m128 in, __m128 drive)
     return x;
 }
 
-__m128 ASYM_SSE2(__m128 in, __m128 drive)
+__m128 ASYM_SSE2(QuadFilterWaveshaperState *__restrict s, __m128 in, __m128 drive)
 {
     const __m128 one = _mm_set1_ps(1.f);
     const __m128 m32 = _mm_set1_ps(32.f);
@@ -715,7 +714,7 @@ __m128 ASYM_SSE2(__m128 in, __m128 drive)
 }
 
 template <int xRes, int xCenter, int size>
-__m128 WS_LUT(const float *table, __m128 in, __m128 drive)
+__m128 WS_LUT(QuadFilterWaveshaperState *__restrict s, const float *table, __m128 in, __m128 drive)
 {
     const __m128 one = _mm_set1_ps(1.f);
     const __m128 m32 = _mm_set1_ps(xRes);
@@ -759,7 +758,7 @@ __m128 WS_LUT(const float *table, __m128 in, __m128 drive)
 
     return x;
 }
-__m128 HALF_RECT_SOFT(__m128 x, __m128 drive)
+__m128 HALF_RECT_SOFT(QuadFilterWaveshaperState *__restrict s, __m128 x, __m128 drive)
 {
     static const auto m1 = _mm_set1_ps(-1.0f);
     static const auto p1 = _mm_set1_ps(1.0f);
@@ -767,16 +766,17 @@ __m128 HALF_RECT_SOFT(__m128 x, __m128 drive)
     static const auto p2 = _mm_set1_ps(2.f);
 
     auto rect = _mm_mul_ps(_mm_sub_ps(abs_ps(x), p05), p2);
-    return TANH(rect, drive);
+    return TANH(s, rect, drive);
 }
 
-template <__m128 (*K)(__m128)> __m128 CHEBY_CORE(__m128 x, __m128 drive)
+template <__m128 (*K)(__m128)>
+__m128 CHEBY_CORE(QuadFilterWaveshaperState *__restrict s, __m128 x, __m128 drive)
 {
     static const auto m1 = _mm_set1_ps(-1.0f);
     static const auto p1 = _mm_set1_ps(1.0f);
 
     auto bound = K(_mm_max_ps(_mm_min_ps(x, p1), m1));
-    return TANH(bound, drive);
+    return TANH(s, bound, drive);
 }
 
 __m128 cheb2_kernel(__m128 x) // 2 x^2 - 1
@@ -977,7 +977,9 @@ WaveshaperQFPtr GetQFPtrWaveshaper(int type)
         return CLIP;
     case wst_asym:
         // return ASYM_SSE2;
-        return [](auto a, auto b) { return WS_LUT<32, 512, 0x3ff>(waveshapers[wst_asym], a, b); };
+        return [](QuadFilterWaveshaperState *__restrict s, auto a, auto b) {
+            return WS_LUT<32, 512, 0x3ff>(s, waveshapers[wst_asym], a, b);
+        };
     case wst_sine:
         return SINUS_SSE2;
     case wst_digital:
diff --git a/src/common/dsp/QuadFilterUnit.h b/src/common/dsp/QuadFilterUnit.h
index 5131cd40ce8..6f02375edde 100644
--- a/src/common/dsp/QuadFilterUnit.h
+++ b/src/common/dsp/QuadFilterUnit.h
@@ -3,6 +3,7 @@
 #include "globals.h"
 
 const int n_filter_registers = 16;
+const int n_waveshaper_registers = 4;
 
 struct alignas(16) QuadFilterUnitState
 {
@@ -13,8 +14,13 @@ struct alignas(16) QuadFilterUnitState
     int WP[4];     // comb write position
 };
 
+struct alignas(16) QuadFilterWaveshaperState
+{
+    __m128 R[n_waveshaper_registers];
+};
+
 typedef __m128 (*FilterUnitQFPtr)(QuadFilterUnitState *__restrict, __m128 in);
-typedef __m128 (*WaveshaperQFPtr)(__m128 in, __m128 drive);
+typedef __m128 (*WaveshaperQFPtr)(QuadFilterWaveshaperState *__restrict, __m128 in, __m128 drive);
 
 FilterUnitQFPtr GetQFPtrFilterUnit(int type, int subtype);
 WaveshaperQFPtr GetQFPtrWaveshaper(int type);
diff --git a/src/common/dsp/SurgeVoice.cpp b/src/common/dsp/SurgeVoice.cpp
index 8b09df74b84..98062f84db2 100644
--- a/src/common/dsp/SurgeVoice.cpp
+++ b/src/common/dsp/SurgeVoice.cpp
@@ -1016,6 +1016,14 @@ void SurgeVoice::SetQFB(QuadFilterChainState *Q, int e) // Q == 0 means init(ial
                  modsources[ms_ampeg]->get_output(0);
     float FB = scene->feedback.get_extended(localcopy[id_feedback].f);
 
+    if (!Q)
+    {
+        // We need to initalize the waveshaper registers
+        for (int c = 0; c < 2; ++c)
+            for (int i = 0; i < n_waveshaper_registers; ++i)
+                FBP.WS[c].R[i] = 0.f;
+    }
+
     if (Q)
     {
         set1f(Q->Gain, e, FBP.Gain);
@@ -1028,6 +1036,14 @@ void SurgeVoice::SetQFB(QuadFilterChainState *Q, int e) // Q == 0 means init(ial
         set1f(Q->dMix1, e, (FMix1 - FBP.Mix1) * BLOCK_SIZE_OS_INV);
         set1f(Q->Mix2, e, FBP.Mix2);
         set1f(Q->dMix2, e, (FMix2 - FBP.Mix2) * BLOCK_SIZE_OS_INV);
+
+        for (int c = 0; c < 2; ++c)
+        {
+            for (int i = 0; i < n_waveshaper_registers; ++i)
+            {
+                set1f(Q->WSS[c].R[i], e, FBP.WS[c].R[i]);
+            }
+        }
     }
 
     FBP.Gain = Gain;
@@ -1175,6 +1191,13 @@ void SurgeVoice::GetQFB()
             }
         }
     }
+    for (int c = 0; c < 2; ++c)
+    {
+        for (int i = 0; i < n_waveshaper_registers; ++i)
+        {
+            FBP.WS[c].R[i] = get1f(fbq->WSS[c].R[i], fbqi);
+        }
+    }
     FBP.FBlineL = get1f(fbq->FBlineL, fbqi);
     FBP.FBlineR = get1f(fbq->FBlineR, fbqi);
     FBP.wsLPF = get1f(fbq->wsLPF, fbqi);
diff --git a/src/common/dsp/SurgeVoice.h b/src/common/dsp/SurgeVoice.h
index fb008eed2bd..dca5c0d9c73 100644
--- a/src/common/dsp/SurgeVoice.h
+++ b/src/common/dsp/SurgeVoice.h
@@ -157,6 +157,10 @@ class alignas(16) SurgeVoice
             unsigned int WP;
             int type, subtype; // used for comparison with the last run
         } FU[4];
+        struct
+        {
+            float R[n_waveshaper_registers];
+        } WS[2];
     } FBP;
     FilterCoefficientMaker CM[2];
 
diff --git a/src/common/dsp/effects/DistortionEffect.cpp b/src/common/dsp/effects/DistortionEffect.cpp
index dca3065f8dd..2235e7cb36a 100644
--- a/src/common/dsp/effects/DistortionEffect.cpp
+++ b/src/common/dsp/effects/DistortionEffect.cpp
@@ -29,6 +29,9 @@ void DistortionEffect::init()
     bi = 0.f;
     L = 0.f;
     R = 0.f;
+
+    for (int i = 0; i < n_waveshaper_registers; ++i)
+        wsState.R[i] = _mm_setzero_ps();
 }
 
 void DistortionEffect::setvars(bool init)
@@ -118,7 +121,7 @@ void DistortionEffect::process(float *dataL, float *dataR)
                 sb[0] = L * dInv;
                 sb[1] = R * dInv;
                 auto lr128 = _mm_load_ps(sb);
-                auto wsres = wsop(lr128, _mm_set1_ps(dNow));
+                auto wsres = wsop(&wsState, lr128, _mm_set1_ps(dNow));
                 _mm_store_ps(sb, wsres);
                 L = sb[0];
                 R = sb[1];
diff --git a/src/common/dsp/effects/DistortionEffect.h b/src/common/dsp/effects/DistortionEffect.h
index 423b6f8346e..70bc3a63dd6 100644
--- a/src/common/dsp/effects/DistortionEffect.h
+++ b/src/common/dsp/effects/DistortionEffect.h
@@ -18,6 +18,7 @@
 #include "BiquadFilter.h"
 #include "DSPUtils.h"
 #include "AllpassFilter.h"
+#include "QuadFilterUnit.h"
 
 #include <vembertech/halfratefilter.h>
 #include <vembertech/lipol.h>
@@ -26,6 +27,7 @@ class DistortionEffect : public Effect
 {
     HalfRateFilter hr_a alignas(16), hr_b alignas(16);
     lipol_ps drive alignas(16), outgain alignas(16);
+    QuadFilterWaveshaperState wsState alignas(16);
 
   public:
     DistortionEffect(SurgeStorage *storage, FxStorage *fxdata, pdata *pd);
diff --git a/src/common/dsp/effects/RotarySpeakerEffect.cpp b/src/common/dsp/effects/RotarySpeakerEffect.cpp
index ec4f7ea8789..d002024c207 100644
--- a/src/common/dsp/effects/RotarySpeakerEffect.cpp
+++ b/src/common/dsp/effects/RotarySpeakerEffect.cpp
@@ -38,6 +38,9 @@ void RotarySpeakerEffect::setvars(bool init)
         drive.instantize();
         width.instantize();
         mix.instantize();
+
+        for (int i = 0; i < n_waveshaper_registers; ++i)
+            wsState.R[i] = _mm_setzero_ps();
     }
 }
 
@@ -263,7 +266,7 @@ void RotarySpeakerEffect::process(float *dataL, float *dataR)
             if (useSSEShaper)
             {
                 auto inp = _mm_set1_ps(0.5 * (dataL[k] + dataR[k]));
-                auto wsres = wsop(inp, _mm_set1_ps(drive_factor));
+                auto wsres = wsop(&wsState, inp, _mm_set1_ps(drive_factor));
                 float r[4];
                 _mm_store_ps(r, wsres);
                 input = r[0] * gain_tweak; // ws + 1 to start on wst_soft
diff --git a/src/common/dsp/effects/RotarySpeakerEffect.h b/src/common/dsp/effects/RotarySpeakerEffect.h
index de44509d191..e5c5f0dfb8b 100644
--- a/src/common/dsp/effects/RotarySpeakerEffect.h
+++ b/src/common/dsp/effects/RotarySpeakerEffect.h
@@ -18,6 +18,7 @@
 #include "BiquadFilter.h"
 #include "DSPUtils.h"
 #include "AllpassFilter.h"
+#include "QuadFilterUnit.h"
 
 #include <vembertech/halfratefilter.h>
 #include <vembertech/lipol.h>
@@ -26,6 +27,7 @@ class RotarySpeakerEffect : public Effect
 {
   public:
     lipol_ps width alignas(16), mix alignas(16);
+    QuadFilterWaveshaperState wsState alignas(16);
 
     RotarySpeakerEffect(SurgeStorage *storage, FxStorage *fxdata, pdata *pd);
     virtual ~RotarySpeakerEffect();
diff --git a/src/headless/UnitTestsDSP.cpp b/src/headless/UnitTestsDSP.cpp
index d550caade51..0f3119b84e4 100644
--- a/src/headless/UnitTestsDSP.cpp
+++ b/src/headless/UnitTestsDSP.cpp
@@ -1020,6 +1020,9 @@ TEST_CASE("Wavehaper LUT", "[dsp]")
 
         auto wst = GetQFPtrWaveshaper(wst_asym);
         auto shafted_tanh = [](double x) { return (exp(x) - exp(-x * 1.2)) / (exp(x) + exp(-x)); };
+        QuadFilterWaveshaperState qss;
+        for (int i = 0; i < n_waveshaper_registers; ++i)
+            qss.R[i] = _mm_setzero_ps();
 
         /*
          * asym:
@@ -1037,7 +1040,7 @@ TEST_CASE("Wavehaper LUT", "[dsp]")
             auto in = _mm_set_ps(x, x + 0.01, x + 0.03, x + 0.05);
             _mm_store_ps(inv, in);
 
-            auto r = wst(in, d);
+            auto r = wst(&qss, in, d);
             _mm_store_ps(out, r);
 
             // sinus has functional form sin((i-512) * PI/512)
